

// Name
//===================================
//
// Background
//

#ifndef BACKGROUND_H
#define BACKGROUND_H


// FORWARD DECLARATIONS
//===================================

    class Camera;


// DEPENDENCIES
//===================================

    #include "counter.h"
    #include "graphics.h"
    #include "timers/timer_repeat.h"


// CLASS
//===================================

    class Background
    {
        public:
            Background
            (
                Graphics::SpriteSheet texture = Graphics::SpriteSheet::LIMIT,
                int width = -1,
                int height = -1,
                int offset_x = 0,
                int offset_y = 0,
                double scroll_speed_x = 1,
                double scroll_speed_y = 1,
                int num_o_frames = 0
            );
            ~Background();
            void render( Graphics& graphics, Camera& camera );

        private:
            Graphics::SpriteSheet texture_ = Graphics::SpriteSheet::CHARSET;
            int x_;
            int y_;
            int width_;
            int height_;
            int offset_x_;
            int offset_y_;
            double scroll_speed_x_;
            double scroll_speed_y_;
            int num_o_frames_;
            Counter current_frame_;
            int other_ = 0;
            TimerRepeat animation_timer_ = TimerRepeat();

            void renderY( Graphics& graphics, Camera& camera );
            void renderX( Graphics& graphics, Camera& camera, int dy, int sy, int h );
    };

#endif // BACKGROUND_H
