


// Name
//===================================
//
// Block
//


// DEPENDENCIES
//===================================

    #include "block.h"
    #include "block_type.h"
    #include "collision.h"
    #include "sprite.h"
    #include <iostream>


// STATIC PROPERTIES
//===================================

// METHODS
//===================================

    Block::Block
    (
    )
    :
        Object( NULLVAL, NULLVAL, 16, 16 ),
        type_ ( nullptr )
    {};

    // DO NOT DELETE BLOCK TYPE. Owned by other class; this holds just a copy.
    Block::~Block() {};

    void Block::render( Graphics& graphics, Camera& camera, bool priority )
    {
        if ( type_ != nullptr )
            type_->render( graphics, camera, *this, priority );
    };

    void Block::neutralize()
    {
        used_ = false;
        hit_box_.x = NULLVAL;
        hit_box_.y = NULLVAL;
        type_ = nullptr;
    };

    void Block::setBlock( int x, int y, BlockType* type, int location )
    {
        used_ = true;
        hit_box_.x = x;
        hit_box_.y = y;
        type_ = type;
        location_ = location;
    };

    int Block::location() const
    {
        return location_;
    };

    void Block::interact( Sprite& sprite, Level& level, EventSystem& events, Inventory& inventory, Camera& camera )
    {
        if ( type_ != nullptr )
        {
            Collision collision = sprite.collide( this );
            type_->interact( collision, sprite, *this, level, events, inventory, camera );
        }
    };
