

// Name
//===================================
//
// BlockComponentLowSlopeLeft
//


// DEPENDENCIES
//===================================

    #include "block.h"
    #include "block_component_low_slope_left.h"
    #include "collision.h"
    #include "sprite.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    BlockComponentLowSlopeLeft::BlockComponentLowSlopeLeft(){};

    BlockComponentLowSlopeLeft::~BlockComponentLowSlopeLeft() {};

    void BlockComponentLowSlopeLeft::interact( Collision& collision, Sprite& sprite, Block& block, Level& level, EventSystem& events, Inventory& inventory, Camera& camera )
    {
        if ( collision.collideAny() )
        {
            if ( sprite.hitboxCenterX() >= block.hitboxLeft() && sprite.hitboxCenterX() <= block.hitboxRight() )
            {
                sprite.collideStopYBottom( 0 );
                if ( sprite.vy_ >= 0 )
                {
                    sprite.hit_box_.y = std::min( sprite.hit_box_.y, block.hitboxBottom() - sprite.hit_box_.h - ( ( sprite.hitboxCenterX() - block.hitboxLeft() ) / 2 ) - 1000 );

                    if ( sprite.vx_ >= 0 && !sprite.isDucking() )
                        sprite.vx_ /= 1.1;
                    else if ( sprite.vx_ <= 0 )
                        sprite.vx_ *= 1.1;

                    if ( sprite.isDucking() )
                        sprite.slideLeft();
                }
            }
        }
    };
