




// Name
//===================================
//
// Clock
//

#ifndef CLOCK_H
#define CLOCK_H


// FORWARD DECLARATIONS
//===================================

    class Graphics;


// DEPENDENCIES
//===================================

    #include <string>
    #include "timers/timer_repeat.h"
    #include "unit.h"


// CLASS
//===================================

    class Clock
    {
        public:
            Clock( int start_time = 0, Direction::Vertical direction = Direction::Vertical::UP, int limit = 599 );
            ~Clock();

            int total_seconds_;
            int limit_;
            Direction::Vertical direction_;

            void update();
            void render( Graphics& graphics, int x, int y );
            static void renderTime( Graphics& graphics, int x, int y, int total_seconds );
            int secondsFromTotal() const;
            int minutesFromTotalSeconds() const;
            static int secondsFromTotal( int total_seconds );
            static int minutesFromTotalSeconds( int total_seconds );
            static std::string timeToString( int total_seconds );
            int totalSeconds() const;
            bool hitLimit() const;

        private:
            static const int SECONDS_PER_MINUTE = 60;
            TimerRepeat timer_ = TimerRepeat( Unit::FPS );
    };

#endif // CLOCK_H

