
// DIRECTIONS
//===================================

#ifndef DIRECTION_H
#define DIRECTION_H


// CLASS
//===================================

    namespace Direction
    {
        enum class Horizontal
        {
            __NULL,
            LEFT,
            RIGHT
        };

        enum class Vertical
        {
            __NULL,
            UP,
            DOWN
        };

        enum class Simple
        {
            __NULL,
            UP,
            RIGHT,
            DOWN,
            LEFT
        };

        enum class Rotation
        {
            __NULL,
            UP,
            UP_RIGHT,
            RIGHT,
            DOWN_RIGHT,
            DOWN,
            DOWN_LEFT,
            LEFT,
            UP_LEFT
        };

        enum class Justify
        {
            AUTO,
            LEFT,
            RIGHT,
            CENTER,
            JUSTIFY
        };

        Simple horizontalToSimple( Horizontal d );
        Simple verticalToSimple( Vertical d );
        Horizontal switchHorizontal( Horizontal d );

    }

#endif // DIRECTION_H

