

// Name
//===================================
//
// Goal
//

#ifndef GOAL_H
#define GOAL_H


// FORWARD DECLARATIONS
//===================================

    class EventSystem;
    class Inventory;
    class PlayerSprite;


// DEPENDENCIES
//===================================

    #include <string>


// CLASS
//===================================

    class Goal
    {

        public:
            enum GoalType
            {
                NORMAL,
                COLLECT,
                TIMED,
                STARVING,
                AVOID_MONEY,
                AVOID_WALLS,
                WINDY
            };

            Goal( std::string message = "¡Get the key!", GoalType type = GoalType::NORMAL, int value = 0 );
            virtual ~Goal();

            virtual void update( PlayerSprite& hero, Inventory& inventory, EventSystem& events );
            std::string message();

            GoalType type() const;
            int value() const;

        protected:
            GoalType type_;
            std::string message_;
            int value_;
    };

#endif // GOAL_H
