




// Name
//===================================
//
// GuardSprite
//


// DEPENDENCIES
//===================================

    #include "camera.h"
    #include "guard_graphics.h"
    #include "guard_sprite.h"
    #include "sprite_graphics.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    GuardSprite::GuardSprite( int x, int y )
    :
        Sprite( new GuardGraphics(), x, y, 16, 24, SpriteType::ENEMY, 1500, 1500 )
    {};

    GuardSprite::~GuardSprite() {};

    void GuardSprite::customUpdate( Input& input, Camera& camera, Map& lvmap, Game& game, EventSystem& events )
    {
        if ( direction_x_ == Direction::Horizontal::RIGHT )
        {
            moveRight();
        }
        else
        {
            moveLeft();
        }

        //if ( collidedRight() || collidedLeft() )
            //direction_x_ = Direction::switchHorizontal( direction_x_ );

        if ( collidedRight() )
        {
            direction_x_ = Direction::Horizontal::LEFT;
            stunned_ = true;
        }
        if ( collidedLeft() )
        {
            direction_x_ = Direction::Horizontal::RIGHT;
            stunned_ = true;
        }

        if ( stunned_ && !stun_timer_.on() )
        {
            stun_timer_.start();
        }
        else if ( stunned_ )
        {
            stun_timer_.update();

            if ( stun_timer_.done() )
                stunned_ = false;
        }
    };

    void GuardSprite::customInteract( Collision& my_collision, Collision& their_collision, Sprite& them )
    {
        if ( them.hasType( SpriteType::HERO ) && !stunned_ )
        {
            if ( direction_x_ == Direction::Horizontal::RIGHT )
            {
                if
                (
                    them.hitboxLeft() > hitboxLeft() &&
                    them.hitboxLeft() < hitboxRight() + DISTANCE_LIMIT_X &&
                    them.hitboxBottom() > hitboxTop() - DISTANCE_LIMIT_Y &&
                    them.hitboxTop() < hitboxBottom() + DISTANCE_LIMIT_Y
                )
                {
                    them.kill();
                }
            }
            else if ( direction_x_ == Direction::Horizontal::LEFT )
            {
                if
                (
                    them.hitboxRight() < hitboxRight() &&
                    them.hitboxRight() > hitboxLeft() - DISTANCE_LIMIT_X &&
                    them.hitboxBottom() > hitboxTop() - DISTANCE_LIMIT_Y &&
                    them.hitboxTop() < hitboxBottom() + DISTANCE_LIMIT_Y
                )
                {
                    them.kill();
                }
            }
        }
    };
