




// Name
//===================================
//
// LevelMessageState
//

#ifndef LEVEL_MESSAGE_STATE_H
#define LEVEL_MESSAGE_STATE_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "game_state.h"
    #include "text.h"


// CLASS
//===================================

    class LevelMessageState : public GameState
    {

        public:
            LevelMessageState( Palette::PaletteSet palette, std::string message );
            ~LevelMessageState();

            void update( Game& game, Input& input, Graphics& graphics );
            void stateRender( Graphics& graphics );
            void init( Game& game, Graphics& graphics );
            void backFromPop( Game& game, Graphics& graphics );

        private:
            static const int MESSAGE_BOX_WIDTH = 160;
            static const int MESSAGE_BOX_HEIGHT = 128;
            Text message_;
            SDL_Rect backdrop_ =
            {
                ( Unit::WINDOW_WIDTH_PIXELS / 2 ) - ( MESSAGE_BOX_WIDTH / 2 ),
                ( Unit::WINDOW_HEIGHT_PIXELS / 2 ) - ( MESSAGE_BOX_HEIGHT / 2 ),
                MESSAGE_BOX_WIDTH,
                MESSAGE_BOX_HEIGHT
            };

    };

#endif // LEVEL_MESSAGE_STATE_H
