

// Name
//===================================
//
// LevelSelectState
//

#ifndef LEVEL_SELECT_STATE_H
#define LEVEL_SELECT_STATE_H


// FORWARD DECLARATIONS
//===================================

    class EventSystem;
    class Inventory;


// DEPENDENCIES
//===================================

    #include "game_state.h"
    #include "level.h"
    #include "sprite_graphics.h"
    #include "text.h"


// CLASS
//===================================

    class LevelSelectState : public GameState
    {

        public:
            LevelSelectState( EventSystem* events = nullptr, Inventory* inventory = nullptr, Level::LevelName level = Level::LevelName::LV_CITY_1 );
            ~LevelSelectState();

            void update( Game& game, Input& input, Graphics& graphics );
            void stateRender( Graphics& graphics );
            void init( Game& game, Graphics& graphics );
            void backFromPop( Game& game, Graphics& graphics );

        private:
            int START_Y = 48;
            int delay_length_ = 16;
            int delay_ = 0;
            EventSystem* events_ = nullptr;
            Inventory* inventory_ = nullptr;
            SDL_Rect highlight_rect_ = { 16, START_Y, Unit::WINDOW_WIDTH_PIXELS - 32, 8 };
            Text title_ = Text( "Select a Level, yo.", 0, 16, Text::FontShade::BLACK, Text::FontAlign::FA_CENTER );
            std::vector<Text> levels_;
            std::vector<Text> levels_gem_scores_;
            std::vector<Text> levels_time_scores_;
            Counter selection_;
            SpriteGraphics win_icon_gfx_ = SpriteGraphics( Graphics::SpriteSheet::LVTILESET_UNIVERSAL, 40, 8 );
            std::vector<SDL_Rect> win_icon_rects_;
            Level::LevelName prev_level_;
    };

#endif // LEVEL_SELECT_STATE_H
