

// Name
//===================================
//
// LevelState
//

#ifndef LEVEL_STATE_H
#define LEVEL_STATE_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "block_system.h"
    #include "camera.h"
    #include "game_state.h"
    #include "event_system.h"
    #include "inventory.h"
    #include "level.h"
    #include "sprite.h"
    #include "player_graphics.h"
    #include "sprite_system.h"


// CLASS
//===================================

    class LevelState : public GameState
    {

        public:
            LevelState( EventSystem& events, Inventory& inventory, Level::LevelName lvname );
            //LevelState( bool show_message = true, int lvname = 0 );
            ~LevelState();

            void update( Game& game, Input& input, Graphics& graphics );
            void stateRender( Graphics& graphics );
            void init( Game& game, Graphics& graphics );
            void backFromPop( Game& game, Graphics& graphics );

        private:
            bool show_message_ = true;
            Level::LevelName current_level_;
            Level level_;
            Camera camera_ = Camera( level_.cameraX(), level_.cameraY() );
            EventSystem events_;
            Inventory& inventory_;
            BlockSystem blocks_;
            SpriteSystem sprites_ = SpriteSystem( level_.entranceX(), level_.entranceY() );
    };

#endif // LEVEL_STATE_H
