

// Name
//===================================
//
// SpriteSystem
//


#ifndef SPRITE_SYSTEM_H
#define SPRITE_SYSTEM_H


// FORWARD DECLARATIONS
//===================================

    class BlockSystem;
    class Camera;
    class EventSystem;
    class Game;
    class Graphics;
    class Input;
    class Inventory;


// DEPENDENCIES
//===================================

    #include "sprite.h"
    #include "player_sprite.h"
    #include <vector>


// CLASS
//===================================

    class SpriteSystem
    {
        public:
            SpriteSystem( int entrance_x, int entrance_y );
            ~SpriteSystem();

            void update( Input& input, Camera& camera, Map& lvmap, Game& game, EventSystem& events );
            void render( Graphics& graphics, Camera& camera );
            void interact( BlockSystem& blocks, Level& level, EventSystem& events, Inventory& inventory, Camera& camera );
            void spriteInteraction( Camera& camera );
            void reset( Map& lvmap );

            PlayerSprite& hero();


        private:
            std::vector<Sprite*> sprites_;
            PlayerSprite hero_;

            void clearSprites();
            void spritesFromMap( Map& lvmap );
            Sprite* spriteType( int type, int x, int y );
    };

#endif // SPRITE_SYSTEM_H
